Loading...
Searching...
No Matches
itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet > Class Template Reference

`#include <itkStatisticalShapePointPenalty.h>`

## Detailed Description

template<class TFixedPointSet, class TMovingPointSet>
class itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >

Computes the Mahalanobis distance between the transformed shape and a mean shape. A model mean and covariance are required.

Author
  F.F. Berendsen, Image Sciences Institute, UMC Utrecht, The Netherlands

Note
  This work was funded by the projects Care4Me and Mediate.
  If you use the StatisticalShapePenalty anywhere we would appreciate if you cite the following article:
  F.F. Berendsen et al., Free-form image registration regularized by a statistical shape model: application to organ segmentation in cervical MR, Comput. Vis. Image Understand. (2013), http://dx.doi.org/10.1016/j.cviu.2012.12.006

Definition at line 56 of file itkStatisticalShapePointPenalty.h.

Inheritance diagram for itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >:
[legend]

## Public Types

using | ConstPointer = SmartPointer<const Self>
using | CoordRepType = typename OutputPointType::CoordRepType
using | DerivativeValueType
using | FixedPointSetConstPointer
using | FixedPointSetType
using | InputPointType
using | MovingPointSetConstPointer
using | MovingPointSetType
using | NonZeroJacobianIndicesType
using | OutputPointType
using | PCACovarianceType = vnl_svd_economy<CoordRepType>
using | PointDataIterator
using | Pointer = SmartPointer<Self>
using | PointIterator
using | ProposalDerivativeType = typename std::vector<VnlVectorType *>
using | Self = StatisticalShapePointPenalty
using | Superclass = SingleValuedPointSetToPointSetMetric<TFixedPointSet, TMovingPointSet>
using | TransformJacobianType
using | TransformParametersType
using | TransformPointer
using | TransformType
using | VnlMatrixType = vnl_matrix<CoordRepType>
using | VnlVectorType = vnl_vector<CoordRepType>
Public Types inherited from itk::SingleValuedPointSetToPointSetMetric< TFixedPointSet, TMovingPointSet >
using | ConstPointer = SmartPointer<const Self>
using | CoordinateRepresentationType = Superclass::ParametersValueType
using | DerivativeValueType = typename DerivativeType::ValueType
using | FixedImageMaskConstPointer = typename FixedImageMaskType::ConstPointer
using | FixedImageMaskPointer = typename FixedImageMaskType::Pointer
using | FixedImageMaskType = ImageMaskSpatialObject<Self::FixedPointSetDimension>
using | FixedPointSetConstPointer = typename FixedPointSetType::ConstPointer
using | FixedPointSetPixelType = typename FixedPointSetType::PixelType
using | FixedPointSetType = TFixedPointSet
using | InputPointType = typename TransformType::InputPointType
using | MovingImageMaskConstPointer = typename MovingImageMaskType::ConstPointer
using | MovingImageMaskPointer = typename MovingImageMaskType::Pointer
using | MovingImageMaskType = ImageMaskSpatialObject<Self::MovingPointSetDimension>
using | MovingPointSetConstPointer = typename MovingPointSetType::ConstPointer
using | MovingPointSetPixelType = typename MovingPointSetType::PixelType
using | MovingPointSetType = TMovingPointSet
using | NonZeroJacobianIndicesType = typename TransformType::NonZeroJacobianIndicesType
using | OutputPointType = typename TransformType::OutputPointType
using | PointDataIterator = typename FixedPointSetType::PointDataContainer::ConstIterator
using | Pointer = SmartPointer<Self>
using | PointIterator = typename FixedPointSetType::PointsContainer::ConstIterator
using | Self = SingleValuedPointSetToPointSetMetric
using | Superclass = SingleValuedCostFunction
using | TransformJacobianType = typename TransformType::JacobianType
using | TransformParametersType = typename TransformType::ParametersType
using | TransformPointer = typename TransformType::Pointer
using | TransformType

## Public Member Functions

virtual void | BaseVarianceNeedsUpdateOff ()
virtual void | BaseVarianceNeedsUpdateOn ()
virtual MeasureType | GetBaseVariance () const
virtual MeasureType | GetCentroidXVariance () const
virtual MeasureType | GetCentroidYVariance () const
virtual MeasureType | GetCentroidZVariance () const
virtual const char * | GetClassName () const
virtual MeasureType | GetCutOffSharpness () const
virtual MeasureType | GetCutOffValue () const
void | GetDerivative (const TransformParametersType &parameters, DerivativeType &Derivative) const override
virtual const bool & | GetNormalizedShapeModel ()
virtual const int & | GetShapeModelCalculation ()
virtual MeasureType | GetShrinkageIntensity () const
virtual MeasureType | GetSizeVariance () const
MeasureType | GetValue (const TransformParametersType &parameters) const override
void | GetValueAndDerivative (const TransformParametersType &parameters, MeasureType &Value, DerivativeType &Derivative) const override
void | Initialize () override
| ITK_DISALLOW_COPY_AND_MOVE (StatisticalShapePointPenalty)
virtual void | NormalizedShapeModelOff ()
virtual void | NormalizedShapeModelOn ()
virtual void | SetBaseVariance (MeasureType _arg)
virtual void | SetBaseVarianceNeedsUpdate (bool _arg)
virtual void | SetCentroidXVariance (MeasureType _arg)
virtual void | SetCentroidYVariance (MeasureType _arg)
virtual void | SetCentroidZVariance (MeasureType _arg)
virtual void | SetCovarianceMatrix (const vnl_matrix< double > *_arg)
virtual void | SetCutOffSharpness (MeasureType _arg)
virtual void | SetCutOffValue (MeasureType _arg)
virtual void | SetEigenValues (const vnl_vector< double > *_arg)
virtual void | SetEigenVectors (const vnl_matrix< double > *_arg)
virtual void | SetMeanVector (const vnl_vector< double > *_arg)
virtual void | SetNormalizedShapeModel (bool _arg)
virtual void | SetShapeModelCalculation (int _arg)
virtual void | SetShrinkageIntensity (MeasureType _arg)
virtual void | SetShrinkageIntensityNeedsUpdate (bool _arg)
virtual void | SetSizeVariance (MeasureType _arg)
virtual void | SetVariancesNeedsUpdate (bool _arg)
virtual void | ShrinkageIntensityNeedsUpdateOff ()
virtual void | ShrinkageIntensityNeedsUpdateOn ()
virtual void | VariancesNeedsUpdateOff ()
virtual void | VariancesNeedsUpdateOn ()
Public Member Functions inherited from itk::SingleValuedPointSetToPointSetMetric< TFixedPointSet, TMovingPointSet >
virtual void | BeforeThreadedGetValueAndDerivative (const TransformParametersType &parameters) const
virtual const FixedImageMaskType * | GetFixedImageMask ()
virtual const FixedPointSetType * | GetFixedPointSet ()
virtual const MovingImageMaskType * | GetMovingImageMask ()
virtual const MovingPointSetType * | GetMovingPointSet ()
unsigned int | GetNumberOfParameters () const override
virtual const TransformType * | GetTransform ()
virtual const bool & | GetUseMetricSingleThreaded ()
| ITK_DISALLOW_COPY_AND_MOVE (SingleValuedPointSetToPointSetMetric)
| itkStaticConstMacro (FixedPointSetDimension, unsigned int, TFixedPointSet::PointDimension)
| itkStaticConstMacro (MovingPointSetDimension, unsigned int, TMovingPointSet::PointDimension)
virtual void | SetFixedImageMask (const FixedImageMaskType *_arg)
virtual void | SetFixedPointSet (const FixedPointSetType *_arg)
virtual void | SetMovingImageMask (const MovingImageMaskType *_arg)
virtual void | SetMovingPointSet (const MovingPointSetType *_arg)
virtual void | SetTransform (TransformType *_arg)
void | SetTransformParameters (const ParametersType &parameters) const
virtual void | SetUseMetricSingleThreaded (bool _arg)
virtual void | UseMetricSingleThreadedOff ()
virtual void | UseMetricSingleThreadedOn ()

## Static Public Member Functions

static Pointer | New ()

## Protected Member Functions

void | PrintSelf (std::ostream &os, Indent indent) const override
| StatisticalShapePointPenalty ()
| ~StatisticalShapePointPenalty () override
Protected Member Functions inherited from itk::SingleValuedPointSetToPointSetMetric< TFixedPointSet, TMovingPointSet >
void | PrintSelf (std::ostream &os, Indent indent) const override
| SingleValuedPointSetToPointSetMetric ()=default
| ~SingleValuedPointSetToPointSetMetric () override=default

## Private Member Functions

void | CalculateCutOffDerivative (typename DerivativeType::element_type &derivativeElement, const MeasureType &value) const
void | CalculateCutOffValue (MeasureType &value) const
void | CalculateDerivative (DerivativeType &derivative, const MeasureType &value, const VnlVectorType &differenceVector, const VnlVectorType &eigrot, const unsigned int shapeLength) const
void | CalculateValue (MeasureType &value, VnlVectorType &differenceVector, VnlVectorType &centerrotated, VnlVectorType &eigrot) const
void | FillProposalDerivative (const OutputPointType &fixedPoint, const unsigned int vertexindex) const
void | FillProposalVector (const OutputPointType &fixedPoint, const unsigned int vertexindex) const
void | NormalizeProposalVector (const unsigned int shapeLength) const
void | UpdateCentroidAndAlignProposalDerivative (const unsigned int shapeLength) const
void | UpdateCentroidAndAlignProposalVector (const unsigned int shapeLength) const
void | UpdateL2 (const unsigned int shapeLength) const
void | UpdateL2AndNormalizeProposalDerivative (const unsigned int shapeLength) const

## Private Attributes

double | m_BaseStd {}
double | m_BaseVariance {}
bool | m_BaseVarianceNeedsUpdate {}
double | m_CentroidXStd {}
double | m_CentroidXVariance {}
double | m_CentroidYStd {}
double | m_CentroidYVariance {}
double | m_CentroidZStd {}
double | m_CentroidZVariance {}
const VnlMatrixType * | m_CovarianceMatrix {}
double | m_CutOffSharpness {}
double | m_CutOffValue {}
const VnlVectorType * | m_EigenValues {}
VnlVectorType * | m_EigenValuesRegularized {}
const VnlMatrixType * | m_EigenVectors {}
VnlMatrixType * | m_InverseCovarianceMatrix {}
VnlVectorType | m_MeanValues {}
const VnlVectorType * | m_MeanVector {}
bool | m_NormalizedShapeModel {}
ProposalDerivativeType * | m_ProposalDerivative {}
unsigned int | m_ProposalLength {}
VnlVectorType | m_ProposalVector {}
int | m_ShapeModelCalculation {}
double | m_ShrinkageIntensity {}
bool | m_ShrinkageIntensityNeedsUpdate {}
double | m_SizeStd {}
double | m_SizeVariance {}
bool | m_VariancesNeedsUpdate {}

## Additional Inherited Members

Protected Attributes inherited from itk::SingleValuedPointSetToPointSetMetric< TFixedPointSet, TMovingPointSet >
FixedImageMaskConstPointer | m_FixedImageMask { nullptr }
FixedPointSetConstPointer | m_FixedPointSet { nullptr }
MovingImageMaskConstPointer | m_MovingImageMask { nullptr }
MovingPointSetConstPointer | m_MovingPointSet { nullptr }
unsigned int | m_NumberOfPointsCounted { 0 }
TransformPointer | m_Transform { nullptr }
bool | m_UseMetricSingleThreaded { true }

## Member Typedef Documentation

## ConstPointer

template<class TFixedPointSet, class TMovingPointSet>

using itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::ConstPointer = SmartPointer<const Self>

Definition at line 66 of file itkStatisticalShapePointPenalty.h.

## CoordRepType

template<class TFixedPointSet, class TMovingPointSet>

using itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::CoordRepType = typename OutputPointType::CoordRepType

Definition at line 95 of file itkStatisticalShapePointPenalty.h.

## DerivativeValueType

template<class TFixedPointSet, class TMovingPointSet>

using itk::SingleValuedPointSetToPointSetMetric< TFixedPointSet, TMovingPointSet >::DerivativeValueType

Definition at line 111 of file itkSingleValuedPointSetToPointSetMetric.h.

## FixedPointSetConstPointer

template<class TFixedPointSet, class TMovingPointSet>

using itk::SingleValuedPointSetToPointSetMetric< TFixedPointSet, TMovingPointSet >::FixedPointSetConstPointer

Definition at line 81 of file itkSingleValuedPointSetToPointSetMetric.h.

## FixedPointSetType

template<class TFixedPointSet, class TMovingPointSet>

using itk::SingleValuedPointSetToPointSetMetric< TFixedPointSet, TMovingPointSet >::FixedPointSetType

Typedefs.

Definition at line 79 of file itkSingleValuedPointSetToPointSetMetric.h.

## InputPointType

template<class TFixedPointSet, class TMovingPointSet>

using itk::SingleValuedPointSetToPointSetMetric< TFixedPointSet, TMovingPointSet >::InputPointType

Definition at line 96 of file itkSingleValuedPointSetToPointSetMetric.h.

## MovingPointSetConstPointer

template<class TFixedPointSet, class TMovingPointSet>

using itk::SingleValuedPointSetToPointSetMetric< TFixedPointSet, TMovingPointSet >::MovingPointSetConstPointer

Definition at line 84 of file itkSingleValuedPointSetToPointSetMetric.h.

## MovingPointSetType

template<class TFixedPointSet, class TMovingPointSet>

using itk::SingleValuedPointSetToPointSetMetric< TFixedPointSet, TMovingPointSet >::MovingPointSetType

Definition at line 82 of file itkSingleValuedPointSetToPointSetMetric.h.

## NonZeroJacobianIndicesType

template<class TFixedPointSet, class TMovingPointSet>

using itk::SingleValuedPointSetToPointSetMetric< TFixedPointSet, TMovingPointSet >::NonZeroJacobianIndicesType

Typedefs for support of sparse Jacobians and compact support of transformations.

Definition at line 115 of file itkSingleValuedPointSetToPointSetMetric.h.

## OutputPointType

template<class TFixedPointSet, class TMovingPointSet>

using itk::SingleValuedPointSetToPointSetMetric< TFixedPointSet, TMovingPointSet >::OutputPointType

Definition at line 97 of file itkSingleValuedPointSetToPointSetMetric.h.

## PCACovarianceType

template<class TFixedPointSet, class TMovingPointSet>

using itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::PCACovarianceType = vnl_svd_economy<CoordRepType>

Definition at line 101 of file itkStatisticalShapePointPenalty.h.

## PointDataIterator

template<class TFixedPointSet, class TMovingPointSet>

using itk::SingleValuedPointSetToPointSetMetric< TFixedPointSet, TMovingPointSet >::PointDataIterator

Definition at line 86 of file itkSingleValuedPointSetToPointSetMetric.h.

## Pointer

template<class TFixedPointSet, class TMovingPointSet>

using itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::Pointer = SmartPointer<Self>

Definition at line 65 of file itkStatisticalShapePointPenalty.h.

## PointIterator

template<class TFixedPointSet, class TMovingPointSet>

using itk::SingleValuedPointSetToPointSetMetric< TFixedPointSet, TMovingPointSet >::PointIterator

Definition at line 85 of file itkSingleValuedPointSetToPointSetMetric.h.

## ProposalDerivativeType

template<class TFixedPointSet, class TMovingPointSet>

using itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::ProposalDerivativeType = typename std::vector<VnlVectorType *>

Definition at line 99 of file itkStatisticalShapePointPenalty.h.

## Self

template<class TFixedPointSet, class TMovingPointSet>

using itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::Self = StatisticalShapePointPenalty

Standard class typedefs.

Definition at line 63 of file itkStatisticalShapePointPenalty.h.

## Superclass

template<class TFixedPointSet, class TMovingPointSet>

using itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::Superclass = SingleValuedPointSetToPointSetMetric<TFixedPointSet, TMovingPointSet>

Definition at line 64 of file itkStatisticalShapePointPenalty.h.

## TransformJacobianType

template<class TFixedPointSet, class TMovingPointSet>

using itk::SingleValuedPointSetToPointSetMetric< TFixedPointSet, TMovingPointSet >::TransformJacobianType

Definition at line 99 of file itkSingleValuedPointSetToPointSetMetric.h.

## TransformParametersType

template<class TFixedPointSet, class TMovingPointSet>

using itk::SingleValuedPointSetToPointSetMetric< TFixedPointSet, TMovingPointSet >::TransformParametersType

Definition at line 98 of file itkSingleValuedPointSetToPointSetMetric.h.

## TransformPointer

template<class TFixedPointSet, class TMovingPointSet>

using itk::SingleValuedPointSetToPointSetMetric< TFixedPointSet, TMovingPointSet >::TransformPointer

Definition at line 95 of file itkSingleValuedPointSetToPointSetMetric.h.

## TransformType

template<class TFixedPointSet, class TMovingPointSet>

using itk::SingleValuedPointSetToPointSetMetric< TFixedPointSet, TMovingPointSet >::TransformType

More typedefs.

Definition at line 93 of file itkSingleValuedPointSetToPointSetMetric.h.

## VnlMatrixType

template<class TFixedPointSet, class TMovingPointSet>

using itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::VnlMatrixType = vnl_matrix<CoordRepType>

Definition at line 97 of file itkStatisticalShapePointPenalty.h.

## VnlVectorType

template<class TFixedPointSet, class TMovingPointSet>

using itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::VnlVectorType = vnl_vector<CoordRepType>

Definition at line 96 of file itkStatisticalShapePointPenalty.h.

## Constructor & Destructor Documentation

## StatisticalShapePointPenalty()

template<class TFixedPointSet, class TMovingPointSet>

itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::StatisticalShapePointPenalty | ( |  | ) |

protected

## ~StatisticalShapePointPenalty()

template<class TFixedPointSet, class TMovingPointSet>

itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::~StatisticalShapePointPenalty | ( |  | ) |

override protected

## Member Function Documentation

## BaseVarianceNeedsUpdateOff()

template<class TFixedPointSet, class TMovingPointSet>

virtual void itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::BaseVarianceNeedsUpdateOff | ( |  | ) |

virtual

## BaseVarianceNeedsUpdateOn()

template<class TFixedPointSet, class TMovingPointSet>

virtual void itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::BaseVarianceNeedsUpdateOn | ( |  | ) |

virtual

## CalculateCutOffDerivative()

template<class TFixedPointSet, class TMovingPointSet>

void itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::CalculateCutOffDerivative | ( | typename DerivativeType::element_type & | derivativeElement,
|  | const MeasureType & | value ) const

private

## CalculateCutOffValue()

template<class TFixedPointSet, class TMovingPointSet>

void itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::CalculateCutOffValue | ( | MeasureType & | value | ) | const

private

## CalculateDerivative()

template<class TFixedPointSet, class TMovingPointSet>

void itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::CalculateDerivative | ( | DerivativeType & | derivative,
|  | const MeasureType & | value,
|  | const VnlVectorType & | differenceVector,
|  | const VnlVectorType & | eigrot,
|  | const unsigned int | shapeLength ) const

private

## CalculateValue()

template<class TFixedPointSet, class TMovingPointSet>

void itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::CalculateValue | ( | MeasureType & | value,
|  | VnlVectorType & | differenceVector,
|  | VnlVectorType & | centerrotated,
|  | VnlVectorType & | eigrot ) const

private

## FillProposalDerivative()

template<class TFixedPointSet, class TMovingPointSet>

void itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::FillProposalDerivative | ( | const OutputPointType & | fixedPoint,
|  | const unsigned int | vertexindex ) const

private

## FillProposalVector()

template<class TFixedPointSet, class TMovingPointSet>

void itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::FillProposalVector | ( | const OutputPointType & | fixedPoint,
|  | const unsigned int | vertexindex ) const

private

## GetBaseVariance()

template<class TFixedPointSet, class TMovingPointSet>

virtual MeasureType itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::GetBaseVariance | ( |  | ) | const

virtual

## GetCentroidXVariance()

template<class TFixedPointSet, class TMovingPointSet>

virtual MeasureType itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::GetCentroidXVariance | ( |  | ) | const

virtual

## GetCentroidYVariance()

template<class TFixedPointSet, class TMovingPointSet>

virtual MeasureType itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::GetCentroidYVariance | ( |  | ) | const

virtual

## GetCentroidZVariance()

template<class TFixedPointSet, class TMovingPointSet>

virtual MeasureType itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::GetCentroidZVariance | ( |  | ) | const

virtual

## GetClassName()

template<class TFixedPointSet, class TMovingPointSet>

virtual const char * itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::GetClassName | ( |  | ) | const

virtual

Run-time type information (and related methods).

Reimplemented from itk::SingleValuedPointSetToPointSetMetric< TFixedPointSet, TMovingPointSet >.

Reimplemented in elastix::StatisticalShapePenalty< TElastix >.

## GetCutOffSharpness()

template<class TFixedPointSet, class TMovingPointSet>

virtual MeasureType itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::GetCutOffSharpness | ( |  | ) | const

virtual

## GetCutOffValue()

template<class TFixedPointSet, class TMovingPointSet>

virtual MeasureType itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::GetCutOffValue | ( |  | ) | const

virtual

## GetDerivative()

template<class TFixedPointSet, class TMovingPointSet>

void itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::GetDerivative | ( | const TransformParametersType & | parameters,
|  | DerivativeType & | Derivative ) const

override

Get the derivatives of the match measure.

## GetNormalizedShapeModel()

template<class TFixedPointSet, class TMovingPointSet>

virtual const bool & itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::GetNormalizedShapeModel | ( |  | ) |

virtual

## GetShapeModelCalculation()

template<class TFixedPointSet, class TMovingPointSet>

virtual const int & itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::GetShapeModelCalculation | ( |  | ) |

virtual

## GetShrinkageIntensity()

template<class TFixedPointSet, class TMovingPointSet>

virtual MeasureType itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::GetShrinkageIntensity | ( |  | ) | const

virtual

## GetSizeVariance()

template<class TFixedPointSet, class TMovingPointSet>

virtual MeasureType itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::GetSizeVariance | ( |  | ) | const

virtual

## GetValue()

template<class TFixedPointSet, class TMovingPointSet>

MeasureType itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::GetValue | ( | const TransformParametersType & | parameters | ) | const

override

Get the value for single valued optimizers.

## GetValueAndDerivative()

template<class TFixedPointSet, class TMovingPointSet>

void itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::GetValueAndDerivative | ( | const TransformParametersType & | parameters,
|  | MeasureType & | Value,
|  | DerivativeType & | Derivative ) const

override

Get value and derivatives for multiple valued optimizers.

## Initialize()

template<class TFixedPointSet, class TMovingPointSet>

void itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::Initialize | ( |  | ) |

override virtual

Initialization.

Reimplemented from itk::SingleValuedPointSetToPointSetMetric< TFixedPointSet, TMovingPointSet >.

## ITK_DISALLOW_COPY_AND_MOVE()

template<class TFixedPointSet, class TMovingPointSet>

itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::ITK_DISALLOW_COPY_AND_MOVE | ( | StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet > |  | ) |

## New()

template<class TFixedPointSet, class TMovingPointSet>

Pointer itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::New | ( |  | ) |

static

Method for creation through the object factory.

## NormalizedShapeModelOff()

template<class TFixedPointSet, class TMovingPointSet>

virtual void itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::NormalizedShapeModelOff | ( |  | ) |

virtual

## NormalizedShapeModelOn()

template<class TFixedPointSet, class TMovingPointSet>

virtual void itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::NormalizedShapeModelOn | ( |  | ) |

virtual

## NormalizeProposalVector()

template<class TFixedPointSet, class TMovingPointSet>

void itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::NormalizeProposalVector | ( | const unsigned int | shapeLength | ) | const

private

## PrintSelf()

template<class TFixedPointSet, class TMovingPointSet>

void itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::PrintSelf | ( | std::ostream & | os,
|  | Indent | indent ) const

override protected

PrintSelf.

## SetBaseVariance()

template<class TFixedPointSet, class TMovingPointSet>

virtual void itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::SetBaseVariance | ( | MeasureType | _arg | ) |

virtual

Set/Get the BaseVariance parameter.

## SetBaseVarianceNeedsUpdate()

template<class TFixedPointSet, class TMovingPointSet>

virtual void itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::SetBaseVarianceNeedsUpdate | ( | bool | _arg | ) |

virtual

## SetCentroidXVariance()

template<class TFixedPointSet, class TMovingPointSet>

virtual void itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::SetCentroidXVariance | ( | MeasureType | _arg | ) |

virtual

## SetCentroidYVariance()

template<class TFixedPointSet, class TMovingPointSet>

virtual void itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::SetCentroidYVariance | ( | MeasureType | _arg | ) |

virtual

## SetCentroidZVariance()

template<class TFixedPointSet, class TMovingPointSet>

virtual void itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::SetCentroidZVariance | ( | MeasureType | _arg | ) |

virtual

## SetCovarianceMatrix()

template<class TFixedPointSet, class TMovingPointSet>

virtual void itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::SetCovarianceMatrix | ( | const vnl_matrix< double > * | _arg | ) |

virtual

## SetCutOffSharpness()

template<class TFixedPointSet, class TMovingPointSet>

virtual void itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::SetCutOffSharpness | ( | MeasureType | _arg | ) |

virtual

## SetCutOffValue()

template<class TFixedPointSet, class TMovingPointSet>

virtual void itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::SetCutOffValue | ( | MeasureType | _arg | ) |

virtual

## SetEigenValues()

template<class TFixedPointSet, class TMovingPointSet>

virtual void itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::SetEigenValues | ( | const vnl_vector< double > * | _arg | ) |

virtual

## SetEigenVectors()

template<class TFixedPointSet, class TMovingPointSet>

virtual void itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::SetEigenVectors | ( | const vnl_matrix< double > * | _arg | ) |

virtual

## SetMeanVector()

template<class TFixedPointSet, class TMovingPointSet>

virtual void itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::SetMeanVector | ( | const vnl_vector< double > * | _arg | ) |

virtual

## SetNormalizedShapeModel()

template<class TFixedPointSet, class TMovingPointSet>

virtual void itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::SetNormalizedShapeModel | ( | bool | _arg | ) |

virtual

## SetShapeModelCalculation()

template<class TFixedPointSet, class TMovingPointSet>

virtual void itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::SetShapeModelCalculation | ( | int | _arg | ) |

virtual

## SetShrinkageIntensity()

template<class TFixedPointSet, class TMovingPointSet>

virtual void itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::SetShrinkageIntensity | ( | MeasureType | _arg | ) |

virtual

Set/Get the shrinkageIntensity parameter.

## SetShrinkageIntensityNeedsUpdate()

template<class TFixedPointSet, class TMovingPointSet>

virtual void itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::SetShrinkageIntensityNeedsUpdate | ( | bool | _arg | ) |

virtual

## SetSizeVariance()

template<class TFixedPointSet, class TMovingPointSet>

virtual void itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::SetSizeVariance | ( | MeasureType | _arg | ) |

virtual

## SetVariancesNeedsUpdate()

template<class TFixedPointSet, class TMovingPointSet>

virtual void itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::SetVariancesNeedsUpdate | ( | bool | _arg | ) |

virtual

## ShrinkageIntensityNeedsUpdateOff()

template<class TFixedPointSet, class TMovingPointSet>

virtual void itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::ShrinkageIntensityNeedsUpdateOff | ( |  | ) |

virtual

## ShrinkageIntensityNeedsUpdateOn()

template<class TFixedPointSet, class TMovingPointSet>

virtual void itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::ShrinkageIntensityNeedsUpdateOn | ( |  | ) |

virtual

## UpdateCentroidAndAlignProposalDerivative()

template<class TFixedPointSet, class TMovingPointSet>

void itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::UpdateCentroidAndAlignProposalDerivative | ( | const unsigned int | shapeLength | ) | const

private

## UpdateCentroidAndAlignProposalVector()

template<class TFixedPointSet, class TMovingPointSet>

void itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::UpdateCentroidAndAlignProposalVector | ( | const unsigned int | shapeLength | ) | const

private

## UpdateL2()

template<class TFixedPointSet, class TMovingPointSet>

void itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::UpdateL2 | ( | const unsigned int | shapeLength | ) | const

private

## UpdateL2AndNormalizeProposalDerivative()

template<class TFixedPointSet, class TMovingPointSet>

void itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::UpdateL2AndNormalizeProposalDerivative | ( | const unsigned int | shapeLength | ) | const

private

## VariancesNeedsUpdateOff()

template<class TFixedPointSet, class TMovingPointSet>

virtual void itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::VariancesNeedsUpdateOff | ( |  | ) |

virtual

## VariancesNeedsUpdateOn()

template<class TFixedPointSet, class TMovingPointSet>

virtual void itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::VariancesNeedsUpdateOn | ( |  | ) |

virtual

## Field Documentation

## m_BaseStd

template<class TFixedPointSet, class TMovingPointSet>

double itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::m_BaseStd {}

private

Definition at line 249 of file itkStatisticalShapePointPenalty.h.

## m_BaseVariance

template<class TFixedPointSet, class TMovingPointSet>

double itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::m_BaseVariance {}

private

Definition at line 248 of file itkStatisticalShapePointPenalty.h.

## m_BaseVarianceNeedsUpdate

template<class TFixedPointSet, class TMovingPointSet>

bool itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::m_BaseVarianceNeedsUpdate {}

private

Definition at line 238 of file itkStatisticalShapePointPenalty.h.

## m_CentroidXStd

template<class TFixedPointSet, class TMovingPointSet>

double itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::m_CentroidXStd {}

private

Definition at line 229 of file itkStatisticalShapePointPenalty.h.

## m_CentroidXVariance

template<class TFixedPointSet, class TMovingPointSet>

double itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::m_CentroidXVariance {}

private

Definition at line 228 of file itkStatisticalShapePointPenalty.h.

## m_CentroidYStd

template<class TFixedPointSet, class TMovingPointSet>

double itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::m_CentroidYStd {}

private

Definition at line 231 of file itkStatisticalShapePointPenalty.h.

## m_CentroidYVariance

template<class TFixedPointSet, class TMovingPointSet>

double itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::m_CentroidYVariance {}

private

Definition at line 230 of file itkStatisticalShapePointPenalty.h.

## m_CentroidZStd

template<class TFixedPointSet, class TMovingPointSet>

double itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::m_CentroidZStd {}

private

Definition at line 233 of file itkStatisticalShapePointPenalty.h.

## m_CentroidZVariance

template<class TFixedPointSet, class TMovingPointSet>

double itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::m_CentroidZVariance {}

private

Definition at line 232 of file itkStatisticalShapePointPenalty.h.

## m_CovarianceMatrix

template<class TFixedPointSet, class TMovingPointSet>

const VnlMatrixType* itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::m_CovarianceMatrix {}

private

Definition at line 222 of file itkStatisticalShapePointPenalty.h.

## m_CutOffSharpness

template<class TFixedPointSet, class TMovingPointSet>

double itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::m_CutOffSharpness {}

private

Definition at line 254 of file itkStatisticalShapePointPenalty.h.

## m_CutOffValue

template<class TFixedPointSet, class TMovingPointSet>

double itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::m_CutOffValue {}

private

Definition at line 253 of file itkStatisticalShapePointPenalty.h.

## m_EigenValues

template<class TFixedPointSet, class TMovingPointSet>

const VnlVectorType* itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::m_EigenValues {}

private

Definition at line 224 of file itkStatisticalShapePointPenalty.h.

## m_EigenValuesRegularized

template<class TFixedPointSet, class TMovingPointSet>

VnlVectorType* itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::m_EigenValuesRegularized {}

private

Definition at line 241 of file itkStatisticalShapePointPenalty.h.

## m_EigenVectors

template<class TFixedPointSet, class TMovingPointSet>

const VnlMatrixType* itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::m_EigenVectors {}

private

Definition at line 223 of file itkStatisticalShapePointPenalty.h.

## m_InverseCovarianceMatrix

template<class TFixedPointSet, class TMovingPointSet>

VnlMatrixType* itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::m_InverseCovarianceMatrix {}

private

Definition at line 226 of file itkStatisticalShapePointPenalty.h.

## m_MeanValues

template<class TFixedPointSet, class TMovingPointSet>

VnlVectorType itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::m_MeanValues {}

mutable private

Definition at line 251 of file itkStatisticalShapePointPenalty.h.

## m_MeanVector

template<class TFixedPointSet, class TMovingPointSet>

const VnlVectorType* itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::m_MeanVector {}

private

Definition at line 221 of file itkStatisticalShapePointPenalty.h.

## m_NormalizedShapeModel

template<class TFixedPointSet, class TMovingPointSet>

bool itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::m_NormalizedShapeModel {}

private

Definition at line 245 of file itkStatisticalShapePointPenalty.h.

## m_ProposalDerivative

template<class TFixedPointSet, class TMovingPointSet>

ProposalDerivativeType* itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::m_ProposalDerivative {}

mutable private

Definition at line 243 of file itkStatisticalShapePointPenalty.h.

## m_ProposalLength

template<class TFixedPointSet, class TMovingPointSet>

unsigned int itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::m_ProposalLength {}

private

Definition at line 244 of file itkStatisticalShapePointPenalty.h.

## m_ProposalVector

template<class TFixedPointSet, class TMovingPointSet>

VnlVectorType itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::m_ProposalVector {}

mutable private

Definition at line 250 of file itkStatisticalShapePointPenalty.h.

## m_ShapeModelCalculation

template<class TFixedPointSet, class TMovingPointSet>

int itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::m_ShapeModelCalculation {}

private

Definition at line 246 of file itkStatisticalShapePointPenalty.h.

## m_ShrinkageIntensity

template<class TFixedPointSet, class TMovingPointSet>

double itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::m_ShrinkageIntensity {}

private

Definition at line 247 of file itkStatisticalShapePointPenalty.h.

## m_ShrinkageIntensityNeedsUpdate

template<class TFixedPointSet, class TMovingPointSet>

bool itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::m_ShrinkageIntensityNeedsUpdate {}

private

Definition at line 237 of file itkStatisticalShapePointPenalty.h.

## m_SizeStd

template<class TFixedPointSet, class TMovingPointSet>

double itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::m_SizeStd {}

private

Definition at line 235 of file itkStatisticalShapePointPenalty.h.

## m_SizeVariance

template<class TFixedPointSet, class TMovingPointSet>

double itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::m_SizeVariance {}

private

Definition at line 234 of file itkStatisticalShapePointPenalty.h.

## m_VariancesNeedsUpdate

template<class TFixedPointSet, class TMovingPointSet>

bool itk::StatisticalShapePointPenalty< TFixedPointSet, TMovingPointSet >::m_VariancesNeedsUpdate {}

private

Definition at line 239 of file itkStatisticalShapePointPenalty.h.

Generated on 1768596610 for elastix by 1.15.0 |